#include "cmsdbfunc.h"

cmsdbfunc::cmsdbfunc(){
	orgid = 0;
	orgname = 0;
}

cmsdbfunc::~cmsdbfunc(){
	if (orgid != 0){
		delete orgid;
		orgid = 0;
	}

	if (orgname != 0){
		delete orgname;
		orgname = 0;
	}
}

//Check if user with given password does exist
bool cmsdbfunc::userlogin(char *username, char *passwd){
	if (orgid != 0){
		delete orgid;
		orgid = 0;
	}

	if (orgname != 0){
		delete orgname;
		orgname = 0;
	}
	
	//TODO: Error checking

	/*
	db = "openchannel";
	dbhost = "localhost";
	dbuser = "root";
	dbpasswd = "quadrant123";
	*/

	mysqlpp::Connection con(db, dbhost, dbuser, dbpasswd);

	mysqlpp::Query query = con.query();

	query << "select * from users where username='" << username << "' and password=password('" << passwd <<"')";

	mysqlpp::Result res = query.store();

	if (res){
		mysqlpp::Row row;
//		mysqlpp::Row::size_type i;

		if (res.size() == 1){
			//Organisation name must also be fetched
			row = res.at(0);

			orgid = createstring((char *)row["orgid"].c_str());

			mysqlpp::Query query2 = con.query();
			
			query2 << "select orgnavn from organisasjoner where orgid='" << orgid << "'";
			mysqlpp::Result res2 = query2.store();

			if (res2){
				mysqlpp::Row row2;

				if (res2.size() == 1){
					row2 = res2.at(0);
					orgname = createstring((char *)row2["orgnavn"].c_str());
				} 
				else return false;
			}
			else return false;

			return true;
		}
/*
		i = 0;
		while (i<res.size()){
			row = res.at(i);
			cout << row["name"] << "\t" << row["password"] << "\t" << "\n";
			i++;
		}
*/
	}

	return false;
}

//Add an incoming file to the database
char *cmsdbfunc::addfile(char *orgid, char *filename){
	mysqlpp::Connection con(db, dbhost, dbuser, dbpasswd);

	mysqlpp::Query query = con.query();

	query << "insert into content (filename, orgid) values ('" << filename << "', '" << orgid << "')";

	mysqlpp::Result res = query.store();

	res.purge();

	query.reset();

	query << "select LAST_INSERT_ID() from content";

	res = query.store();

	if (res.columns() == 1){
		mysqlpp::Row row = res.fetch_row();
		return createstring((char *)row["LAST_INSERT_ID()"].c_str());
	}

	return 0;
}

//Tell the database the file is uploaded
bool cmsdbfunc::setuploaded(char *media_id){
	mysqlpp::Connection con(db, dbhost, dbuser, dbpasswd);

	mysqlpp::Query query = con.query();

	query << "update content set fin_upload='yes' where contentid='" << media_id << "'";

	mysqlpp::Result res = query.store();

	return true;
}

void cmsdbfunc::setdb(char *sdb){
	db=sdb;
}

void cmsdbfunc::setdbhost(char *sdbhost){
	dbhost=sdbhost;
}

void cmsdbfunc::setdbuser(char *sdbuser){
	dbuser=sdbuser;
}

void cmsdbfunc::setdbpasswd(char *sdbpasswd){
	dbpasswd=sdbpasswd;
}

void cmsdbfunc::setorgname(char *sorgname){
	orgname=sorgname;
}

char *cmsdbfunc::getorgname(){
	return orgname;
}

char *cmsdbfunc::getorgid(){
	return orgid;
}

/***************************************************************
 * Method: getszlength
 *    Returns the length of the given zero terminated string
 *    including the zero itself, 0x0a is converted to 0x00
 ***************************************************************/

static int getszlength(char *instring){
	//In case of null pointer input
	if (instring == 0) return 0;

	//Search from the beginnig of the string
	int count = 0;

	//Until first occurence of a null character
	char ch = 0x00;
	do{
		ch = *(instring+(count++));
	} while ((ch != '\0') && (ch != 0x0a));

	*((instring+(count))-1) = 0x00;

	//return the found count (plus one)
	return count+1;
}

/***************************************************************
 * Method: createszstring
 *    Creates a dynamic string from a constant
 *    TODO: Replace this with proper string handling
 ***************************************************************/

static char *createstring(char *instring){
	//Get the input (constant) string's length
	int length = getszlength(instring);

	//Create room for the dynamic string
	char *tempstring = new char[length];

	//Copy the content of the constant string to the dynamic
	for (int i = 0; i<length; i++){
		tempstring[i] = instring[i];
	}

	//Return the pointer to the newly created string
	return tempstring;
}
