/*
 * Owner:			pen kanal (C) 2005
 *
 * Description:		Class to manage multiple network connections (header file)
 *
 */

typedef struct tag_client_sockets{
	int socket_id;
	int last_error;
	SOCKET socket;
	int state;
	bool active;
	int dummy;

	tag_client_sockets *next_client_socket;
} CLIENT_SOCKETS, *LPCLIENT_SOCKETS;

class cmsserverclass{

private:
	int listen_port;
	int last_error;
	WSADATA wsadata;
	SOCKET server_socket;
	sockaddr_in server_service;
	int dummy;

	int next_socket_id;
	CLIENT_SOCKETS *client_sockets;
	CLIENT_SOCKETS *first_client_socket;
	CLIENT_SOCKETS *last_client_socket;

	int addsocket(SOCKET socket);
	CLIENT_SOCKETS *findSocket(int socket_id);

public:
	cmsserverclass();
	cmsserverclass(int listen_port);
	int connect(char *listenip);
	int checkforconnection();
	int readConnection(char *buffer, int *buffer_size);
	int writeConnection(int socket_id, char *buffer, int buffer_size);
	void remsocket(int socket_id);
	int lerror();
};

