<?php

// Paaloggingsbildet
// PHP av Roy Galaasen

// Dersom bruker er paalogget, omdiriger til hovedsiden;
// dersom ikke, presenter paaloggingsbildet.

  // -------------------------
  // --- Initialisasjon:   ---
  // -------------------------

  include_once("_designlib_.php");
  include_once("_dblib_.php");
  include_once("_htmllib_.php");
  include_once("_contentlib_.php");
  include_once("_funklib_.php");

  // Hent brukerens ip adresse
  $ip=getenv("REMOTE_ADDR");

  // Hent sesjonsidentifikatoren om den finnes
  $sessid=$_GET["sessid"];

  // Hent inntastet brukernavn og passord om det eksisterer
  $bnavn=$_POST["bnavn"];
  $opwd=$_POST["opwd"];
  $npwd1=$_POST["npwd1"];
  $npwd2=$_POST["npwd2"];
  $action=$_POST["action"];

  // Valider alle brukerinnmatede parametre
  $bnavn=validate($bnavn);
  $opwd=validate($opwd);
  $npwd1=validate($npwd1);
  $npwd2=validate($npwd2);
  $sessid=validate($sessid);
  $action=validate($action);

  // -------------------------
  // --- Test for tilgang: ---
  // -------------------------

  connect();
  selectdb("openchannel");

  // Adgang ikke tillatt uten videre
  $accepted = false;
  // Sjekke om bruker har tilgang
  $accepted = validate_user($sessid, $ip);

  //Dersom bruker har tilgang, presenter bildet for endring
  if ($accepted) {

    $uttext="";

    //Hent brukerid for denne sesjonen
    $uid=0;
    $result=mysql_query("select userid from users where sessid=\"$sessid\" and lastip=\"$ip\"");
    $row=mysql_fetch_assoc($result);
    if ($row){
      $uid=$row["userid"];
    } else $uttext="Alvorlig feil: Kunne ikke finne din brukersesjon";

    //Utfoere kun dersom bruker ble funnet
    if ($uid!=0){

      if ($action=="Endre brukernavn"){
        //Sjekke at brukernavnet er ok
        if (!isalphanum($bnavn)) $uttext="Kun alfanumeriske tegn i brukernavn!";
        else if ($bnavn=="") $uttext="Du kan ikke registrere blankt brukernavn!";
        else{
          $result=mysql_query("select * from users where username=\"$bnavn\"");
          $row=mysql_fetch_assoc($result);
          if ($row){
            $uttext="Brukernavnet er i bruk!";
          } else {
              mysql_query("update users set username=\"$bnavn\" where userid=\"$uid\"");
              $uttext="Brukernavnet er endret!";
          }
        }
      }

      if ($action=="Endre passord"){
        $result=mysql_query("select password, password(\"$opwd\") from users where userid=\"$uid\"");
        $row=mysql_fetch_assoc($result);
        if ($row["password(\"$opwd\")"]!=$row["password"]) $uttext="Gammelt passord stemmer ikke!";
        else if ($npwd1!=$npwd2) $uttext="Passordene matcher ikke!";
        else if (!goodpass($npwd1)) $uttext="Du m&aring; nok finne et bedre passord!";
        else{
          mysql_query("update users set password=password(\"$npwd1\") where userid=\"$uid\"");
          $uttext="Passordet er byttet";
        }
      }
    }

    designtop();
    contentmenu();
    designmiddle();

    //Vise tekst som passer med oensket oppgave
    echo "<h3>Tast inn ditt nye ";
    if ($action!="Endre passord") echo "brukernavn";
    if (($action!="Endre passord") && ($action!="Endre brukernavn")) echo " eller ";
    if ($action!="Endre brukernavn") echo "passord";
    echo ":</h3>\n";

    echo "<form action=\"editpassnick.php?sessid=$sessid\" method=\"post\">\n";
    echo "<table>\n";

    //Ikke vise dersom det er passord som skal endres
    if ($action!="Endre passord"){
      echo " <tr>\n";
      echo "  <td>Brukernavn:</td>\n";
      echo "  <td>" . itext("bnavn", "40") . "</td>\n";
      echo " </tr>\n";
      echo " <tr>\n";
      echo "  <td>&nbsp;</td>\n";
      echo "  <td>" . isubmit("Endre brukernavn", "action") . "</td>\n";
      echo " </tr>\n";
    }

    //Ikke vise dersom det er brukernavn som skal endres
    if ($action!="Endre brukernavn"){
      echo "<tr><td>&nbsp;</td><td>&nbsp;</td></tr>\n";
      echo " <tr>\n";
      echo "  <td>Gammelt passord:</td>\n";
      echo "  <td>" . ipwd("opwd", "40") . "</td>\n";
      echo " </tr>\n";
      echo " <tr>\n";
      echo "  <td>Nytt passord:</td>";
      echo "  <td>" . ipwd("npwd1", "40") . "</td>\n";
      echo " </tr>\n";
      echo " <tr>\n";
      echo "  <td>Gjenta nytt passord:</td>";
      echo "  <td>" . ipwd("npwd2", "40") . "</td>\n";
      echo " </tr>\n";
      echo " <tr>\n";
      echo "  <td>&nbsp;</td>\n";
      echo "  <td>" . isubmit("Endre passord", "action") . "</td>\n";
      echo " </tr>\n";
    }

    echo "</table>\n";
    echo "</form>\n";

    if ($uttext!="") echo "<font color=\"ff0000\"><h3>$uttext</h3></font>";

    designbottom();
  }
  //Dersom bruker ikke har tilgang, omdiriger til paaloggingsbildet
  else {
    header("Location: http://jail.babylon.uninett.no/registrering");
  }

?>


